# -*- coding: utf-8 -*-
# SplashScreen.py
# generated by wxGlade 0.6.3 on Fri Feb 27 11:02:30 2009

import wx
import threading
from ChatWindow import *
from base64 import b64encode as crypt
from base64 import b64decode as decrypt #;-O
import urllib

class SplashScreen(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: SplashScreen.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE & ~ (wx.RESIZE_BORDER | wx.RESIZE_BOX | wx.MAXIMIZE_BOX)
        wx.Frame.__init__(self, *args, **kwds)
        self.pic1 = wx.StaticBitmap(self, -1, wx.Bitmap("pixmaps/login.png", wx.BITMAP_TYPE_ANY))
        self.CreateLoginPanel()
        self.CreateLogPanel()
        self.LoadCard()
        self.ID_Timer = wx.NewId()
        self.timer = wx.Timer(self, self.ID_Timer)
        wx.EVT_TIMER(self, self.ID_Timer, self.end)
        self.FirstRun = True
        self.__set_properties()
        self.__do_layout()
        self.__bind_events()
        # end wxGlade

    def LoadCard(self):
        self.cfg = wx.Config('delphichat6')
        if self.cfg.Exists('storepass'):
            self.cbSave.SetValue(self.cfg.ReadBool('storepass'))
        if self.cfg.Exists('username'):
            self.textUserName.SetValue(self.cfg.Read('username'))
        if self.cfg.Exists('password'):
            passw = decrypt(self.cfg.Read('password'))
            self.textPassword.SetValue(passw)
        if self.cfg.Exists('proxyaddr'):
            self.textProxyAddr.SetValue(self.cfg.Read('proxyaddr'))
        if self.cfg.Exists('proxyuser'):
            passw = decrypt(self.cfg.Read('proxyuser'))
            self.textProxyUser.SetValue(passw)

    def SaveCard(self):
        storepass = self.cbSave.GetValue()
        if storepass:
            passw = crypt(self.textPassword.GetValue().encode("utf-8"))
        else:
            passw = ''
        self.cfg.Write("password", passw)
        self.cfg.Write("username",self.textUserName.GetValue())
        self.cfg.WriteBool("storepass", storepass)

        self.cfg.Write("proxyaddr",self.textProxyAddr.GetValue())
        self.cfg.Write("proxyuser",crypt(self.textProxyUser.GetValue()))
        self.cfg.Flush()

    def CreateLoginPanel(self):
        self.LoginPanel = wx.Panel(self, -1)
        textUserNameLabel = wx.StaticText(self.LoginPanel, -1, u"Имя пользователя:",pos=(4,0))
        self.textUserName = wx.TextCtrl(self.LoginPanel, -1, "",pos=(4,15), size=(290,-1))
        textPasswordLabel = wx.StaticText(self.LoginPanel, -1, u"Пароль:",pos=(4,45))
        self.textPassword = wx.TextCtrl(self.LoginPanel, -1, "",pos=(4,60), size=(290,-1), style=wx.TE_PASSWORD)
        self.cbSave = wx.CheckBox(self.LoginPanel, -1, u'Запомнить', pos=(4, 85))

        ##Proxy
        textProxyAddrLabel = wx.StaticText(self.LoginPanel, -1, u"Адрес прокси [Addr:Port]:",pos=(4,115))
        self.textProxyAddr = wx.TextCtrl(self.LoginPanel, -1, "",pos=(4,130), size=(290,-1))
        textProxyUserLabel = wx.StaticText(self.LoginPanel, -1, u"Пользователь прокси [User:Password]:",pos=(4,160))
        self.textProxyUser = wx.TextCtrl(self.LoginPanel, -1, "",pos=(4,175), size=(290,-1))
        self.btnE = wx.Button(self.LoginPanel, wx.NewId(), u"Войти в чат!",pos=(160,220), size=(130, -1))

    def CreateLogPanel(self):
        self.LogPanel = wx.Panel(self, -1)
        self.txtLoadLog = wx.TextCtrl(self.LogPanel, -1, "",pos=(0,4),size=(294, 200), style=wx.TE_MULTILINE|wx.TE_READONLY|wx.NO_BORDER)
        self.btnLog = wx.Button(self.LogPanel, wx.NewId(), u"Ещё раз!",pos=(160,220), size=(130, -1))
        self.LogPanel.Hide()
        self.btnLog.Hide()

    def __set_properties(self):
        # begin wxGlade: SplashScreen.__set_properties
        self.SetTitle("Delphi Chat 6 [Login]")
        _icon = wx.Icon("pixmaps/MAINICON.ico", wx.BITMAP_TYPE_ICO)
        self.SetIcon(_icon)
        #?self.SetSize((400, 300))
        self.SetBackgroundColour(wx.Colour(255, 255, 255))
        self.LoginPanel.SetBackgroundColour(wx.Colour(255, 255, 255))
        self.LogPanel.SetBackgroundColour(wx.Colour(255, 255, 255))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: SplashScreen.__do_layout
        sizerLeft = wx.BoxSizer(wx.HORIZONTAL)
        sizerRight = wx.BoxSizer(wx.VERTICAL)
        sizerLeft.Add(self.pic1, 0, 0, 0)
        sizerRight.Add(self.LoginPanel, 1, wx.EXPAND|wx.ALL, 7)
        sizerRight.Add(self.LogPanel, 1, wx.EXPAND|wx.ALL, 7)
        sizerLeft.Add(sizerRight, 1, wx.EXPAND, 0)
        self.SetSizer(sizerLeft)
        sizerLeft.Fit(self)
        self.btnE.SetFocus()
        self.Layout()
        self.Centre()
        #Логин Тут!
        #threading._start_new_thread(Login, (self,))

        # end wxGlade

    def __bind_events(self):
        self.Bind(common.EVT_CHAT_NOTIFY_EVENT, self.NotyfyHandler)
        self.Bind(wx.EVT_BUTTON, self.OnEClick, id=self.btnE.GetId())
        self.Bind(wx.EVT_BUTTON, self.OnLogErrorClick, id=self.btnLog.GetId())

    def SwapPanels(self, showLog):
        if showLog:
            self.LoginPanel.Hide()
            self.LogPanel.Show()
            #self.btnLog.SetFocus()
        else:
            self.LogPanel.Hide()
            self.LoginPanel.Show()
            self.btnE.SetFocus()
        self.Layout()

    def OnLogErrorClick(self, event):
        self.SwapPanels(False)
        self.btnLog.Hide()

    def OnEClick(self, event):
        self.SaveCard()
        self.btnE.Hide()
        common.UserName = self.textUserName.GetValue()
        common.UserPassword = self.textPassword.GetValue()
        common.ProxyAddr = self.textProxyAddr.GetValue()
        common.ProxyPass = self.textProxyUser.GetValue()
        #Нет, Логин Тут!!
        self.SwapPanels(True)
        threading._start_new_thread(common.Login, (self,))


    def NotyfyHandler(self, evt):
        if (evt.type == common.NOTIFY_TAKSTATUS):
            self.txtLoadLog.AppendText(evt.status+"\n")
            #self.btnE.Hide()
        if (evt.type == common.NOTIFY_LOGIN_OK):
            self.timer.Start(500)
        if(evt.type == common.NOTIFY_LOGIN_FAILED):
            self.btnLog.SetFocus()
            self.btnLog.Show()
            self.btnE.Show()

    def end(self,evt):
        self.timer.Stop()
        self.LoginOk()

    def LoginOk(self):
        CWindow = ChatWindow(None, -1, '')
        wx.GetApp().SetTopWindow(CWindow)
        CWindow.Show()
        CWindow.Raise()
        self.Destroy()

# end of class SplashScreen


