# socketm.py
# -*- coding: utf-8 -*-
import httplib, urllib, re, sys, base64
from log import DoLog, debptint

def GetChatId(cookiestr):
    try:
        cid = re.search('chatid=(.+?);',cookiestr).group(1)
    except:
        cid = ''
    return cid

def GetPage(RequestType, URL, Cookies, Content, ProxyAddr, ProxyPass, version):
    purl = httplib.urlsplit(URL)
    host = purl.netloc
    params = urllib.urlencode(Content)
    uagent = "Delphi chat 6/%s (%s)" % (version, sys.platform.strip())

    if ProxyAddr=="":
        conn = httplib.HTTPConnection(host)
    else:
        conn = httplib.HTTPConnection(ProxyAddr)
    try:
        conn.connect()
        if RequestType=="GET" and params!="":
            URL=URL+"?"+params
            contentlength = '0'
        else:
            contentlength = str(len(params))
        conn.putrequest(RequestType, URL)
        conn.putheader('User-Agent', uagent)
        conn.putheader('Accept', "*/*")
        conn.putheader('Content-type', "application/x-www-form-urlencoded")
        conn.putheader('Cache-Control', "max-age=0")
        if Cookies!="":
            conn.putheader('Cookie', Cookies)

        if ProxyPass!="" and ProxyAddr!="":
            conn.putheader('Proxy-Authorization', "Basic %s" % base64.b64encode(ProxyPass))

        #if len(params)!=0 and RequestType=="POST":
        conn.putheader('Content-Length', contentlength)

        conn.endheaders()
        if len(params)!=0 and RequestType=="POST":
            conn.send(params)
    except Exception, ex:
        DoLog("Error occurred in connect to %s [%s %s]" % (host, ex.args, ex.message))
        return {"status":500, "cookie": "", "content":""}

    try:
        response = conn.getresponse()
        status = response.status
        hcookie = response.getheader('set-cookie')
        data = response.read()
    except Exception, ex:
        DoLog('Error occurred in socketm.py | GetPage %s [%s %s]' % (URL, ex.args, ex.message))
        status = 501
        hcookie = ''
        data = ''
    finally:
        conn.close()
    return {"status":status, "cookie": hcookie, "content":data}
